/*
 * -------------------------------------------------------------------------
 * dwt.h -- Declarations for wavelet functions.
 * SWT - Scilab wavelet toolbox
 * Copyright (C) 2005-2006  Roger Liu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * -------------------------------------------------------------------------
 */

#include "swt_common.h"

/*********************************************
 * Macros
 ********************************************/

#define DAUBECHIES     1

#define NOT_DEFINED    99

//OTRH could be deleted by changing it to wi
#define ORTH       0
//#define BIORTH     1


/*********************************************
 * Wavelet Structure Declarations
 ********************************************/

typedef struct {
//  int     length; //Now FILTER_LEN defined at parameters.h
  double  * pLowPass;
  double  * pHiPass;
} swt_wavelet;

typedef void(*Func)(swt_wavelet *pWaveStruct);

/*
typedef struct {
  char  wname[20];
  int   rOrB;
  int   family;
  int   member;
  Func  analysis;
  Func  synthesis;
} wavelet_identity;*/



/*********************************************
 * Global Variable Declaration
 ********************************************/

//extern double LowDecomFilCoef[80];
//extern double LowReconFilCoef[80];
//extern double HiDecomFilCoef[80];
//extern double HiReconFilCoef[80];
//extern int waveletIdentityNum; /*ok asi*/
//extern extend_method dwtMode;
//extern wavelet_identity wi[]; /*ok asi*/
//extern extension_identity ei[];
//extern int extensionIdentityNum;
//extern str_error_notification strErrNoti[];


//extern wavelet_identity wi[];




/*********************************************
 * Function Prototype
 ********************************************/

void daubechies_analysis_initialize (double *, double *);
void daubechies_synthesis_initialize (double *, double *);

