/*
 * -------------------------------------------------------------------------
 * dwt1d.c -- 1-D signal decomposition and reconstruction
 * SWT - Scilab wavelet toolbox
 * Copyright (C) 2005-2006  Roger Liu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * -------------------------------------------------------------------------
 */
//#include "swt_common.h"
#include "dwt.h"
#include "parameters.h"
#include "arq.h"

#if ARQ_x86 == 0
#include <dsplib.h>
#endif

/*
wavelet_identity wi[] = {
  {"db1", ORTH, DAUBECHIES, 1, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db2", ORTH, DAUBECHIES, 2, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db3", ORTH, DAUBECHIES, 3, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db4", ORTH, DAUBECHIES, 4, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db5", ORTH, DAUBECHIES, 5, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db6", ORTH, DAUBECHIES, 6, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db7", ORTH, DAUBECHIES, 7, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db8", ORTH, DAUBECHIES, 8, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db9", ORTH, DAUBECHIES, 9, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db10", ORTH, DAUBECHIES, 10, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db11", ORTH, DAUBECHIES, 11, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db12", ORTH, DAUBECHIES, 12, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db13", ORTH, DAUBECHIES, 13, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db14", ORTH, DAUBECHIES, 14, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db15", ORTH, DAUBECHIES, 15, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db16", ORTH, DAUBECHIES, 16, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db17", ORTH, DAUBECHIES, 17, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db18", ORTH, DAUBECHIES, 18, daubechies_analysis_initialize, daubechies_synthesis_initialize}, 
  {"db19", ORTH, DAUBECHIES, 19, daubechies_analysis_initialize, daubechies_synthesis_initialize},
  {"db20", ORTH, DAUBECHIES, 20, daubechies_analysis_initialize, daubechies_synthesis_initialize}
};

int waveletIdentityNum = sizeof(wi)/sizeof(wavelet_identity);
*/
extend_method dwtMode = SYMH;

/*-------------------------------------------
 * wavelet name parser
 *-----------------------------------------*/
/*
void
filter_clear ()
{
  int count;
  for(count=0;count<30;count++)
    {
//      LowDecomFilCoef[count] = 0;
//      LowReconFilCoef[count] = 0;
  //    HiDecomFilCoef[count] = 0;
//      HiReconFilCoef[count] = 0;
    }
  return;
}*/
/*
void
wavelet_parser (char *wname, int *family, int *member)
{
  int count;

  *family = NOT_DEFINED;
  *member = NOT_DEFINED;
  for(count=0;count<waveletIdentityNum;count++)
    {
      if (strcmp(wname,wi[count].wname) == 0)
	{
	  *family = wi[count].family;
	  *member = wi[count].member;
	  break;
	}
    }
  return;
}
void
wavelet_fun_parser (char *wname, int *ii)
{
  int count;

  *ii = -1;
  for(count=0;count<waveletIdentityNum;count++)
    {
      if (strcmp(wname,wi[count].wname) == 0)
	{
	  *ii = count;
	  break;
	}
    }
  return;
}

void
wave_len_validate (int sigInLen, int waveLength, int *lev, int *val)
{
  int n;
  int m;

  *val = 0;
  if (sigInLen < 2*waveLength)
    {
      *lev = 0;
      *val = 0;
      return;
    }
  else
    {
      *val = 1;
      *lev = 0;
      n = sigInLen;
      do
	{
	  m = (int)floor((n + waveLength - 1)/2);
	  *lev += 1;
	  n = m;
	}
      while (m>=2*waveLength);
      return;
    }
}
*/

#if 0

void
dwt_write (char *mode, int *errCode)
{
/*
extension_identity ei[] = {
  {"zpd", ZPD}, {"symh", SYMH}, {"symw", SYMW},
  {"asymh", ASYMH}, {"asymw", ASYMW}, {"sp0", SP0},
  {"sp1", SP1}, {"ppd", PPD}, {"per", PER},
  {"spd", SP1}, {"sym", SYMH}, {"asym", ASYMH},
  {"ZPD", ZPD}, {"SYMH", SYMH}, {"SYMW", SYMW},
  {"ASYMH", ASYMH}, {"ASYMW", ASYMW}, {"SP0", SP0},
  {"SP1", SP1}, {"PPD", PPD}, {"PER", PER},
  {"SPD", SP1},  {"SYM", SYMH}, {"ASYM", ASYMH} 
};

int extensionIdentityNum = sizeof(ei)/sizeof(extension_identity);

  int count;
  *errCode = UNKNOWN_INPUT_ERR;
  
  for (count=0;count<extensionIdentityNum;count++)
    {
      if (strcmp(mode,ei[count].extMethodName) == 0)
	{
	  dwtMode = ei[count].extMethod;
	  *errCode = SUCCESS;
	  break;
	}
    }*/
  *errCode = UNKNOWN_INPUT_ERR;

  #if METHOD == ASYMH || METHOD == SYMH
  dwtMode = METHOD;
  *errCode = SUCCESS;
  #endif

  return;
}
#endif

double sigInTemp[DWT_SIGINTEMP_LEN];
double approxTemp1[DWT_APPROXTEMP_LEN];
double approxPre1[DWT_APPROXPRE_LEN]; 
double detailTemp1 [DWT_APPROXPRE_LEN];
double detailPre1 [DWT_APPROXPRE_LEN];

void
dwt_neo (double *sigIn, int sigInLength, double *lowDe, 
     double *hiDe, int filterLen, double *approx, 
     double *detail, int sigOutLength, extend_method extMethod)
{
  wextend_1D_center (sigIn, sigInLength, sigInTemp, DWT_SIGINTEMP_LEN, extMethod); /*OK*/

  conv1 (sigInTemp, DWT_SIGINTEMP_LEN, approxTemp1, DWT_APPROXTEMP_LEN, lowDe, filterLen);/*OK*/

  wkeep_1D_center (approxTemp1, DWT_APPROXTEMP_LEN, approxPre1, DWT_APPROXPRE_LEN);
  dyaddown_1D_keep_even (approxPre1, DWT_APPROXPRE_LEN,approx,sigOutLength);
  
  conv1 (sigInTemp, DWT_SIGINTEMP_LEN, detailTemp1, DWT_APPROXTEMP_LEN, hiDe, filterLen);

  wkeep_1D_center (detailTemp1, DWT_APPROXTEMP_LEN, detailPre1, DWT_APPROXPRE_LEN);
   
  dyaddown_1D_keep_even (detailPre1, DWT_APPROXPRE_LEN,detail,sigOutLength);

  return;
}

double approxTemp[IDWT_SIGIN_LEN];
double detailTemp[IDWT_SIGIN_LEN];
double approxPre[IDWT_SIGOUT_LEN];
double detailPre[IDWT_SIGOUT_LEN];
double sigOutPre[IDWT_SIGOUT_LEN];

void
idwt_neo (double *approx, double *detail, int sigInLength, 
	       double *lowRe, double *hiRe, int filterLen, 
	       double *sigOut, int sigOutLength) 
{
  int count;//, ind;

  
  dyadup_1D_feed_even (approx, sigInLength, approxTemp, IDWT_SIGIN_LEN);

  dyadup_1D_feed_even (detail, sigInLength, detailTemp, IDWT_SIGIN_LEN);

  conv2 (approxTemp, IDWT_SIGIN_LEN, approxPre, IDWT_SIGOUT_LEN, lowRe, filterLen);
  conv2 (detailTemp, IDWT_SIGIN_LEN, detailPre, IDWT_SIGOUT_LEN, hiRe, filterLen);

  for(count=0;count<IDWT_SIGOUT_LEN;count++)
    sigOutPre[count] = approxPre[count] + detailPre[count];

  wkeep_1D_center (sigOutPre, IDWT_SIGOUT_LEN, sigOut, sigOutLength);

  return;
}
