#include "main.h"

int main (int argc, char** argv)
{
	char filename[] = "marked.wav";
	WaveData embededVoice = {0,0,NULL};
	int result;
	WAVHeader header;
	unsigned long i;
	unsigned long extracted;
	short *where, *initialWhere;

	/* Loading the voice from the file */
	if (argc > 2 && *argv[2]== '-')
	{
		result = loadSamples (&embededVoice,argv[1]);
	}
	else if (argc > 1)
	{
		result = loadVoice (&embededVoice,&header,argv[1]);
	}
	else
	{
		result = loadVoice (&embededVoice,&header,filename);
	}
	
	/* Calling the extracting method */
//	WaveData embededVoice;

	if (result)
	{
		DWT_INIT();

		printf ("size is: %d\n", embededVoice.soundLength);
		initialWhere = (short*)embededVoice.sample;
		for (i=0; i<embededVoice.soundLength;i++)
		{
			
			where = (short*)&embededVoice.sample[i];
			//if ((i+7+3)%10 == 0 && (argc > 2 && *argv[2]== 'v' || argc > 3 && *argv[3]== 'v'))
			if ((i)%1 == 0 && (argc > 2 && *argv[2]== 'v' || argc > 3 && *argv[3]== 'v'))
			{
				printf ("A new value: %0002d   %0002x\n",*(unsigned char *)where,*(unsigned char*)where);
			}

			/* Searching the syn mark... */
			if (testSynMark(where) == 0)
			{
				/* if found! */
				extracted = extractMethod (where+SYN_NSAMPLES);
				printf ("MARK FOUND! :D --> extracted: %ld. posicion=%ld\n",extracted, i/2);
			}
		}
	}

	/* free allocated dynamic memory */
	if (embededVoice.sample)
		free(embededVoice.sample);

	printf ("PROCESS ENDED OK!!!\n");

	return 0;
}


