/*
 * -------------------------------------------------------------------------
 * logarithmic.h -- Logarithmic quantization
 * Speech Watermarkin
 * Copyright (C) 2011-2012  Oriol Parera Fiestas
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * -------------------------------------------------------------------------
 */

#ifndef LOGARITHMIC_H
#define LOGARITHMIC_H

#include "arq.h"
#if ARQ_x86
	#include <math.h>
	#include <stdio.h>
#endif

#include <stdlib.h>
#include "parameters.h"


/**
* @brief Procedure for hiding one bit into a given spectrum 
*
* @param spectrum
* @param bit
*/
void hideBit (double *spectrum, const unsigned short bit);


/**
* @brief Procedure for getting one bit into a given spectrum 
*
* @param spectrum
* @param bit
*/
void getHidenBit (const double *spectrum, unsigned short * bit);

#endif /* LOGARITHMIC_H*/
