/*
 * -------------------------------------------------------------------------
 * swt_common.h -- Declarations for wavelet functions.
 * SWT - Scilab wavelet toolbox
 * Copyright (C) 2005-2007  Roger Liu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * -------------------------------------------------------------------------
 */

#ifndef __SWT_H__
#define __SWT_H__ 1

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
//#include "stack-c.h"

/*********************************************
 * Macro
 ********************************************/

#define SUCCESS      0
#define DIM_ERR_ONE  1
#define DIM_ERR_VEC  2
#define DIM_ERR_MAT  3


#define POSITIVE_INTEGER_ONLY                               1
#define LENGTH_DATA_NOT_VALID_FOR_VECTOR_DIMENSION          2
#define SIZE_DATA_NOT_VALID_FOR_MATRIX_DIMENSION            3
#define OPT_CHAR_NOT_VALID                                  4
#define EXTENSION_OPT_NOT_VALID                             5
#define WAVELET_NAME_NOT_VALID                              6
#define DECOMPOSITION_LEVEL_NOT_VALID                       7
#define MULTI_DECOM_LEVEL_LESS_THAN_TWO                     8
#define WRONG_LHS                                           9
#define UNKNOWN_INPUT_ERR                                   20

#define PI      3.1415926535


/*********************************************
 * Extension Type
 ********************************************/

typedef enum {
  ZPD, SYMH, SYMW, ASYMH, ASYMW, 
  SP0, SP1, PPD, PER} extend_method;

#endif 
