#include "watermarking.h"

unsigned long extractMethod (const sample_t dataShort)
{	
	unsigned long bitsReversed=0;
	unsigned long bits=0;

	unsigned i=0;
	unsigned short extractedBit;
	double * doubleConverted = data;
	sample_t shortSample = (sample_t)dataShort;
	double * nextBlock;
	
	/* convert to double */
	for (i=0;i<MARK_SAMPLES;i++)
	{
		//fast way to cast to doyble
		*doubleConverted++ = *shortSample++; 
	}

	DWT (data,approx,detail);

	/* Here must be extracted the information */
	nextBlock = approx;
	for (i=0;i<MARK_BITS_TO_CODE;i++)
	{
		extractedBit = 0;

		getHidenBit (nextBlock,&extractedBit);

		nextBlock += MARK_SPEC_SAMPLES_PER_BIT; 

#if TEST_WATERMARKING
//		printf ("extracted bit: %d\n",extractedBit);
#endif
		bits=bits>>1;
		bits = extractedBit==0? bits&0x7fffffff:bits|0x80000000;
	}
	for(;i<32;i++)
	{
		bits=bits>>1;
		bits = bits&0x7fffffff;
	}
#if TEST_WATERMARKING
//	printf ("bits: %x\n"); 
#endif

	return bits;
}

void embedMethod (sample_t dataShort, const unsigned long mark)
{
//	const unsigned long bit = 0;
	unsigned long bits = mark;
	unsigned i=0;

	unsigned short bit = 0;
	double * nextBlock;

	double * doubleConverted = data;
	short * shortSample = dataShort;
#if TEST_WATERMARKING
	unsigned short recoveredBit;
	unsigned encerts=0;
	unsigned total=0;
#endif
	
	//Very fast cast from short to double
	for (i=0;i<MARK_SAMPLES;i++)
	{
		*doubleConverted++ = *shortSample++;
	}

    	/* Gone to the frecuency domain */
	DWT (data,approx,detail);

	/* marking the bits */
	nextBlock = approx;
	for (i=0;i<MARK_BITS_TO_CODE;i++)
	{
//		bit = checkBit (((char*)&bits)[0],i);
		bit = (unsigned short) (bits & 0x00000001);
		bits=bits>>1;
//		nextBlock = &approx[i*MARK_SPEC_SAMPLES_PER_BIT];

		if (bit>0)
			hideBit (nextBlock,1);
		else
			hideBit (nextBlock,0);

#if TEST_WATERMARKING
		getHidenBit (nextBlock,&recoveredBit);
//		printf ("hidden: %d & extracted: %d. \n",bit,recoveredBit);
		if (bit==recoveredBit) encerts++;
		total++;
#endif

		nextBlock += MARK_SPEC_SAMPLES_PER_BIT;
	}
#if TEST_WATERMARKING
/*	printf ("OK Values: %d de %d. It is a %f%\n",encerts, total, encerts*100.0/total);

	for (i=0;i<MARK_SPEC_HALF_SAMPLES;i++)
	{
		printf ("approx[%d]=%f\n",i,approx[i]);
	}*/
#endif

	/* Back to the Temporal Domain */
	iDWT (approx,detail,data);

#if TEST_WATERMARKING
/*	double approx2[MARK_SPEC_HALF_SAMPLES], detail2[MARK_SPEC_HALF_SAMPLES];
	DWT (data,approx2,detail2);
	for (i=0;i<MARK_SPEC_HALF_SAMPLES;i++)
	{
		printf ("approx2[%d]=%f\n",i,approx2[i]);
	}*/
#endif

	//Very fast cast from double to short
	doubleConverted = data;
	shortSample = dataShort;
	for (i=0;i<MARK_SAMPLES;i++)
	{
		*shortSample++ = (int)(0.5+ (*doubleConverted++));
	}
}


